Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 > Class Template Reference

Mixed (n+1)-ary propagator. More...

`#include <pattern.hpp>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| MixNaryOnePropagator (Space &home, MixNaryOnePropagator &p)
| Constructor for cloning p.
| MixNaryOnePropagator (Home home, ViewArray< View0 > &x, View1 y)
| Constructor for creation.
| MixNaryOnePropagator (Space &home, Propagator &p, ViewArray< View0 > &x, View1 y)
| Constructor for rewriting p during cloning.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< View0 > | x
| Array of views.
View1 | y
| Single view.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class View0, PropCond pc0, class View1, PropCond pc1>
class Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >

Mixed (n+1)-ary propagator.

Stores array of views of type View0 with propagation condition pc0 and a single view of type View1 with propagation condition pc1.

If the propagation conditions pc0 or pc1 have the values PC_GEN_NONE, no subscriptions are created.

Definition at line 272 of file pattern.hpp.

## Constructor & Destructor Documentation

## MixNaryOnePropagator() [1/3]

template<class View0, PropCond pc0, class View1, PropCond pc1>

Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::MixNaryOnePropagator | ( | Space & | home,
|  | MixNaryOnePropagator< View0, pc0, View1, pc1 > & | p )

inline protected

Constructor for cloning p.

Definition at line 732 of file pattern.hpp.

## MixNaryOnePropagator() [2/3]

template<class View0, PropCond pc0, class View1, PropCond pc1>

Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::MixNaryOnePropagator | ( | Home | home,
|  | ViewArray< View0 > & | x,
|  | View1 | y )

protected

Constructor for creation.

Definition at line 721 of file pattern.hpp.

## MixNaryOnePropagator() [3/3]

template<class View0, PropCond pc0, class View1, PropCond pc1>

Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::MixNaryOnePropagator | ( | Space & | home,
|  | Propagator & | p,
|  | ViewArray< View0 > & | x,
|  | View1 | y )

inline protected

Constructor for rewriting p during cloning.

Definition at line 741 of file pattern.hpp.

## Member Function Documentation

## cost()

template<class View0, PropCond pc0, class View1, PropCond pc1>

PropCost Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low linear).

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Bool::NaryOr< VX, VY >, Gecode::Int::Channel::LinkMulti, Gecode::Int::NValues::IntBase< VY >, Gecode::Set::Channel::ChannelBool< View >, Gecode::Set::RelOp::IntersectionN< View0, View1 >, Gecode::Set::RelOp::PartitionN< View0, View1 >, and Gecode::Set::RelOp::UnionN< View0, View1 >.

Definition at line 750 of file pattern.hpp.

## reschedule()

template<class View0, PropCond pc0, class View1, PropCond pc1>

void Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Bool::NaryOr< VX, VY >, Gecode::Int::Channel::LinkMulti, and Gecode::Set::Channel::ChannelBool< View >.

Definition at line 757 of file pattern.hpp.

## dispose()

template<class View0, PropCond pc0, class View1, PropCond pc1>

size_t Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Reimplemented in Gecode::Int::Bool::NaryOr< VX, VY >, Gecode::Int::Channel::LinkMulti, Gecode::Int::NValues::EqInt< VY >, Gecode::Int::NValues::IntBase< VY >, Gecode::Int::NValues::LqInt< VY >, and Gecode::Set::Channel::ChannelBool< View >.

Definition at line 766 of file pattern.hpp.

## Member Data Documentation

## x

template<class View0, PropCond pc0, class View1, PropCond pc1>

ViewArray<View0> Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::x

protected

Array of views.

Definition at line 275 of file pattern.hpp.

## y

template<class View0, PropCond pc0, class View1, PropCond pc1>

View1 Gecode::MixNaryOnePropagator< View0, pc0, View1, pc1 >::y

protected

Single view.

Definition at line 277 of file pattern.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/propagator/pattern.hpp